--- D:/nobackup/netgen-master/libsrc/meshing/_improve3.cpp	Sa Sep 22 12:50:59 2018
+++ D:/nobackup/netgen-master/libsrc/meshing/improve3.cpp	Sa Okt 13 01:08:58 2018
@@ -841,6 +841,11 @@ void MeshOptimize3d :: SwapImprove (Mesh & mesh, O
 
 	      if (bad2 < bad1)
 		{
+		  if (bad2 >= 1e23)
+		    {
+		      cout << "nsuround = " << nsuround << " ei = " << int(ei) << endl;
+		      continue;
+		    }
 		  //		  (*mycout) << "3->2 " << flush;
 		  //		  (*testout) << "3->2 conversion" << endl;
 		  cnt++;
@@ -1104,6 +1109,11 @@ void MeshOptimize3d :: SwapImprove (Mesh & mesh, O
 
 	      if (swap2)
 		{
+		  if (bad2 >= 1e23)
+		    {
+		      cout << "nsuround = " << nsuround << " ei = " << int(ei) << endl;
+		      continue;
+		    }
 		  //		  (*mycout) << "bad1 = " << bad1 << " bad2 = " << bad2 << "\n";
 
 
@@ -1138,6 +1148,11 @@ void MeshOptimize3d :: SwapImprove (Mesh & mesh, O
 		}
 	      else if (swap3)
 		{
+		  if (bad3 >= 1e23)
+		    {
+		      cout << "nsuround = " << nsuround << " ei = " << int(ei) << endl;
+		      continue;
+		    }
 		  // (*mycout) << "bad1 = " << bad1 << " bad3 = " << bad3 << "\n";
 		  el1b.flags.illegal_valid = 0;
 		  el2b.flags.illegal_valid = 0;
@@ -1207,6 +1222,7 @@ void MeshOptimize3d :: SwapImprove (Mesh & mesh, O
 
 	      tetused = false;
 	      tetused[0] = true;
+	      int ntetu = 1;
 
 	      for (int l = 2; l < nsuround; l++)
 		{
@@ -1226,10 +1242,13 @@ void MeshOptimize3d :: SwapImprove (Mesh & mesh, O
 				- pi1 - pi2 - oldpi;
 
 			      tetused[k] = true; 
+			      ntetu++;
 			      suroundpts[l] = newpi;
 			    }
 			}
 		}
+	      if (ntetu+1 != nsuround)
+                throw NgException("Illegal state created in SwapImprove");
 	      
 	      
 	      bad1 = 0;
@@ -1331,6 +1350,11 @@ void MeshOptimize3d :: SwapImprove (Mesh & mesh, O
 
 	      if (bestl != -1)
 		{
+		  if (badopt >= 1e23)
+		    {
+		      cout << "nsuround = " << nsuround << " ei = " << int(ei) << endl;
+		      continue;
+		    }
 		  // (*mycout) << nsuround << "->" << 2 * (nsuround-2) << " " << flush;
 		  cnt++;
 		  
